summaryrefslogtreecommitdiffstats
path: root/checkpkg.in
diff options
context:
space:
mode:
Diffstat (limited to 'checkpkg.in')
-rw-r--r--checkpkg.in90
1 files changed, 90 insertions, 0 deletions
diff --git a/checkpkg.in b/checkpkg.in
new file mode 100644
index 0000000..cde3dc2
--- /dev/null
+++ b/checkpkg.in
@@ -0,0 +1,90 @@
+#!/bin/bash
+
+# Source makepkg.conf; fail if it is not found
+if [[ -r '/etc/makepkg.conf' ]]; then
+ source '/etc/makepkg.conf'
+else
+ echo '/etc/makepkg.conf not found!'
+ exit 1
+fi
+
+# Source user-specific makepkg.conf overrides
+if [[ -r ~/.makepkg.conf ]]; then
+ source ~/.makepkg.conf
+fi
+
+if [[ ! -f PKGBUILD ]]; then
+ echo 'This must be run in the directory of a built package.'
+ exit 1
+fi
+
+. PKGBUILD
+if [[ $arch == 'any' ]]; then
+ CARCH='any'
+fi
+
+STARTDIR=$(pwd)
+TEMPDIR=$(mktemp -d --tmpdir checkpkg-script.XXXX)
+cd "$TEMPDIR"
+
+for _pkgname in "${pkgname[@]}"; do
+ if [[ -z ${epoch} ]] ; then
+ pkgfile=${_pkgname}-${pkgver}-${pkgrel}-${CARCH}${PKGEXT}
+ else
+ pkgfile=${_pkgname}-${epoch}:${pkgver}-${pkgrel}-${CARCH}${PKGEXT}
+ fi
+
+ if [[ -f "$STARTDIR/$pkgfile" ]]; then
+ ln -s "$STARTDIR/$pkgfile" "$pkgfile"
+ elif [[ -f "$PKGDEST/$pkgfile" ]]; then
+ ln -s "$PKGDEST/$pkgfile" "$pkgfile"
+ else
+ echo "File \"$pkgfile\" doesn't exist"
+ exit 1
+ fi
+
+ pkgurl=$(pacman -Spdd --print-format '%l' --noconfirm "$_pkgname")
+
+ if [[ $? -ne 0 ]]; then
+ echo "Couldn't download previous package for $_pkgname."
+ exit 1
+ fi
+
+ oldpkg=${pkgurl##*://*/}
+
+ if [[ ${oldpkg##*/} = ${pkgfile##*/} ]]; then
+ echo "The built package ($_pkgname) is the one in the repo right now!"
+ exit 1
+ fi
+
+ if [[ ! -f $oldpkg ]]; then
+ if [[ $pkgurl = file://* ]]; then
+ ln -s "${pkgurl#file://}" "${pkgurl##file://*/}"
+ elif [[ -f "$PKGDEST/$oldpkg" ]]; then
+ ln -s "$PKGDEST/$oldpkg" "$oldpkg"
+ elif [[ -f "$STARTDIR/$oldpkg" ]]; then
+ ln -s "$STARTDIR/$oldpkg" "$oldpkg"
+ else
+ wget --quiet "$pkgurl"
+ fi
+ fi
+
+ bsdtar tf "$oldpkg" | sort > "filelist-$_pkgname-old"
+ bsdtar tf "$pkgfile" | sort > "filelist-$_pkgname"
+
+ sdiff -s "filelist-$_pkgname-old" "filelist-$_pkgname"
+
+ if diff "filelist-$_pkgname-old" "filelist-$_pkgname" | grep '\.so' > /dev/null 2>&1; then
+ mkdir -p pkg
+ cd pkg
+ bsdtar xf ../"$pkgfile" > /dev/null
+ diff "../filelist-$_pkgname-old" "../filelist-$_pkgname" | awk '/>.*\.so/{$1 = ""; print $0}' | while read i; do
+ echo "${i}: " "$(objdump -p "$i" | grep SONAME)"
+ done
+ cd ..
+ else
+ echo "No soname differences for $_pkgname."
+ fi
+done
+
+echo "Files saved to $TEMPDIR"